/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// ProtocolsOverviewProtocols struct for ProtocolsOverviewProtocols
type ProtocolsOverviewProtocols struct {
	// The protocol name.
	Handle *string `json:"handle,omitempty"`
	// The network type, i.e., mainnet, testnet, etc.
	Network *string `json:"network,omitempty"`
}

// NewProtocolsOverviewProtocols instantiates a new ProtocolsOverviewProtocols object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewProtocolsOverviewProtocols() *ProtocolsOverviewProtocols {
	this := ProtocolsOverviewProtocols{}
	return &this
}

// NewProtocolsOverviewProtocolsWithDefaults instantiates a new ProtocolsOverviewProtocols object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewProtocolsOverviewProtocolsWithDefaults() *ProtocolsOverviewProtocols {
	this := ProtocolsOverviewProtocols{}
	return &this
}

// GetHandle returns the Handle field value if set, zero value otherwise.
func (o *ProtocolsOverviewProtocols) GetHandle() string {
	if o == nil || o.Handle == nil {
		var ret string
		return ret
	}
	return *o.Handle
}

// GetHandleOk returns a tuple with the Handle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProtocolsOverviewProtocols) GetHandleOk() (*string, bool) {
	if o == nil || o.Handle == nil {
		return nil, false
	}
	return o.Handle, true
}

// HasHandle returns a boolean if a field has been set.
func (o *ProtocolsOverviewProtocols) HasHandle() bool {
	if o != nil && o.Handle != nil {
		return true
	}

	return false
}

// SetHandle gets a reference to the given string and assigns it to the Handle field.
func (o *ProtocolsOverviewProtocols) SetHandle(v string) {
	o.Handle = &v
}

// GetNetwork returns the Network field value if set, zero value otherwise.
func (o *ProtocolsOverviewProtocols) GetNetwork() string {
	if o == nil || o.Network == nil {
		var ret string
		return ret
	}
	return *o.Network
}

// GetNetworkOk returns a tuple with the Network field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProtocolsOverviewProtocols) GetNetworkOk() (*string, bool) {
	if o == nil || o.Network == nil {
		return nil, false
	}
	return o.Network, true
}

// HasNetwork returns a boolean if a field has been set.
func (o *ProtocolsOverviewProtocols) HasNetwork() bool {
	if o != nil && o.Network != nil {
		return true
	}

	return false
}

// SetNetwork gets a reference to the given string and assigns it to the Network field.
func (o *ProtocolsOverviewProtocols) SetNetwork(v string) {
	o.Network = &v
}

func (o ProtocolsOverviewProtocols) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Handle != nil {
		toSerialize["handle"] = o.Handle
	}
	if o.Network != nil {
		toSerialize["network"] = o.Network
	}
	return json.Marshal(toSerialize)
}

type NullableProtocolsOverviewProtocols struct {
	value *ProtocolsOverviewProtocols
	isSet bool
}

func (v NullableProtocolsOverviewProtocols) Get() *ProtocolsOverviewProtocols {
	return v.value
}

func (v *NullableProtocolsOverviewProtocols) Set(val *ProtocolsOverviewProtocols) {
	v.value = val
	v.isSet = true
}

func (v NullableProtocolsOverviewProtocols) IsSet() bool {
	return v.isSet
}

func (v *NullableProtocolsOverviewProtocols) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProtocolsOverviewProtocols(val *ProtocolsOverviewProtocols) *NullableProtocolsOverviewProtocols {
	return &NullableProtocolsOverviewProtocols{value: val, isSet: true}
}

func (v NullableProtocolsOverviewProtocols) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProtocolsOverviewProtocols) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
